unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, srMVUnit, DataUnit;

type

  { f̒ʒm󂯂郊Xi[NX }
  TView1Listener = class(TObserver)
    public
      procedure Update(AObservable:TObservable; AArg:TObject);override;
  end;

  { l𕶎Ƃĕ\r[NX}
  TView1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    //Xi[NXĂяoXV\bh
    procedure UpdateView(AData:TModel);
  public
    { Public 錾 }
    Listener:TView1Listener;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy;override;
  end;

var
  View1: TView1;

implementation

uses Unit2;

{$R *.DFM}

{ TView1Listener }

procedure TView1Listener.Update(AObservable: TObservable; AArg: TObject);
begin

  View1.UpdateView(AObservable as TModel);

end;

{ TView1 }

procedure TView1.UpdateView(AData: TModel);
begin

  Label1.Caption := IntToStr(Data.Number);
  Edit1.Text := IntToStr(Data.Number);

end;

procedure TView1.Button1Click(Sender: TObject);
begin

  Data.Number := StrToIntDef(Edit1.Text, 0);

end;

constructor TView1.Create(AOwner: TComponent);
begin

  inherited;
  Listener := TView1Listener.Create;

end;

destructor TView1.Destroy;
begin

  Listener.Free;
  inherited;

end;

procedure TView1.Button2Click(Sender: TObject);
begin

  Data.AddObserver(View2.Listener);

end;

procedure TView1.Button3Click(Sender: TObject);
begin

  Data.DeleteObserver(View2.Listener);

end;

end.
